using System;
using System.Windows.Forms;

namespace FelicaSimpleServer
{
	/// <summary>
	/// Util ̊Tv̐łB
	/// </summary>
	public class Util
	{
		public static MainForm form = null;

		//bZ[Wo͂D
		public static void PrintMessage(string m, params object []args)
		{
			PrintMessage(false, m, args);
		}

		public static void PrintMessage(bool status, string m, params object []args)
		{
			if(form ==null || !form.Initialized)
				return;

			string message = String.Format(m, args);
			if(form.MessageEnabled)
				form.SetMessage(message);

			if(status)
				form.SetStatusBar(message);
		}

		//ASCIIoCgɕϊ
		public static byte[] ConvertStrToBytes(string str)
		{
			byte [][] dummyBytes = new byte[str.Length][];
			byte [] bytes = new byte[str.Length];
			char [] dummyChars = str.ToCharArray(0,str.Length);

			int allLength = 0;
			for(int i=0;i<dummyChars.Length;i++)
			{
				dummyBytes[i] = BitConverter.GetBytes(dummyChars[i]);
				
				for(int j = 0;j<dummyBytes[i].Length-1;j++)
				{
					bytes[allLength + j] = dummyBytes[i][j];
				}
				allLength = allLength + dummyBytes[i].Length - 1;
			}
			return bytes;
		}

		//oCgASCIIɕϊ
		public static string ConvertBytesToStr(byte [] bytes, int length)
		{
			char [] dummyChars = new char[length];
			string str;

			for(int i=0;i<length;i++)
			{
				dummyChars[i] = Convert.ToChar(bytes[i]);
			}
			
			str = new String(dummyChars);
			return str;
		}
		
		//oCgz̖NUL菜
		public static byte[] ChopBytes(byte [] bytes)
		{
			int cnt=0;
			byte [] choppedBytes;
			for(int i= bytes.Length;i>0;i--)
			{
				if(bytes[i-1] == 0x00)
				{
					cnt ++;
				}
				else
				{
					break;
				}
			}
			if(cnt < bytes.Length)
			{
				choppedBytes = new byte [bytes.Length - cnt];
				Array.Copy(bytes,0,choppedBytes,0,bytes.Length - cnt);
				return choppedBytes;
			}
			else
			{
				return null;
			}
		}
	}
}
